__version__ = '0.8a2'

import unittest
import xml.dom

import cssutils.css


class CSSValueTestCase(unittest.TestCase):

        
    def test_init(self):
        """
        check   cssText (initially empty)
                cssValueType
        """        
        v = cssutils.css.CSSValue()
        self.assertEqual(u'inherit', v.cssText)
        self.assertEqual(v.CSS_INHERIT, v.cssValueType)

        v = cssutils.css.CSSValue(cssText=u'inherit')
        self.assertEqual(u'inherit', v.cssText)
        self.assertEqual(v.CSS_INHERIT, v.cssValueType)

        v = cssutils.css.CSSValue(cssText=u'red')
        self.assertEqual(u'red', v.cssText)
        self.assertEqual(v.CSS_CUSTOM, v.cssValueType)

        # TODO: more init tests

    def test_readonly(self):
        v = cssutils.css.CSSValue(readonly=True)
        self.assertEqual(True, v._readonly)
        self.assertEqual(u'inherit', v.cssText)
        self.assertRaises(xml.dom.NoModificationAllowedErr, v._setCssText, u'x')
        self.assertEqual(u'inherit', v.cssText)
                        
    def test_cssText(self):
        v = cssutils.css.CSSValue()
        v.cssText = u'1'
        self.assertEqual(v.CSS_CUSTOM, v.cssValueType)
        self.assertEqual(u'1', v.cssText)

        v.cssText = u'  1   px    '
        self.assertEqual(v.CSS_CUSTOM, v.cssValueType)
        self.assertEqual('1 px', v.cssText)


if __name__ == '__main__':
    unittest.main() 